/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /       
 */

package com.twilio.sdk.fetcher.preview.wireless.device;

import com.twilio.sdk.client.TwilioRestClient;
import com.twilio.sdk.exception.ApiConnectionException;
import com.twilio.sdk.exception.ApiException;
import com.twilio.sdk.fetcher.Fetcher;
import com.twilio.sdk.http.HttpMethod;
import com.twilio.sdk.http.Request;
import com.twilio.sdk.http.Response;
import com.twilio.sdk.resource.RestException;
import com.twilio.sdk.resource.preview.wireless.device.Usage;

public class UsageFetcher extends Fetcher<Usage> {
    private final String deviceSid;
    private String end;
    private String start;

    /**
     * Construct a new UsageFetcher.
     * 
     * @param deviceSid The device_sid
     */
    public UsageFetcher(final String deviceSid) {
        this.deviceSid = deviceSid;
    }

    /**
     * The end.
     * 
     * @param end The end
     * @return this
     */
    public UsageFetcher setEnd(final String end) {
        this.end = end;
        return this;
    }

    /**
     * The start.
     * 
     * @param start The start
     * @return this
     */
    public UsageFetcher setStart(final String start) {
        this.start = start;
        return this;
    }

    /**
     * Make the request to the Twilio API to perform the fetch.
     * 
     * @param client TwilioRestClient with which to make the request
     * @return Fetched Usage
     */
    @Override
    @SuppressWarnings("checkstyle:linelength")
    public Usage execute(final TwilioRestClient client) {
        Request request = new Request(
            HttpMethod.GET,
            TwilioRestClient.Domains.PREVIEW,
            "/wireless/Devices/" + this.deviceSid + "/Usage",
            client.getAccountSid()
        );
        
        addQueryParams(request);
        Response response = client.request(request);
        
        if (response == null) {
            throw new ApiConnectionException("Usage fetch failed: Unable to connect to server");
        } else if (!TwilioRestClient.SUCCESS.apply(response.getStatusCode())) {
            RestException restException = RestException.fromJson(response.getStream(), client.getObjectMapper());
            if (restException == null) {
                throw new ApiException("Server Error, no content");
            }
        
            throw new ApiException(
                restException.getMessage(),
                restException.getCode(),
                restException.getMoreInfo(),
                restException.getStatus(),
                null
            );
        }
        
        return Usage.fromJson(response.getStream(), client.getObjectMapper());
    }

    /**
     * Add the requested query string arguments to the Request.
     * 
     * @param request Request to add query string arguments to
     */
    private void addQueryParams(final Request request) {
        if (end != null) {
            request.addQueryParam("End", end);
        }
        
        if (start != null) {
            request.addQueryParam("Start", start);
        }
    }
}